function $i(e) { return document.getElementById(e);}

var win = window.nativeWindow;

function doCalc(base)
{
 frm0=parseInt ($i('frames0h').value);
 frm1=parseInt ($i('frames1h').value);
 if(frm0>=frm1) mi='A-B'; else mi= 'A&harr;B';
 $i('res').innerHTML='<h1>A+B = '+tcstring(frm0+frm1,base)+' ('+(frm0+frm1)+' frames) @ '+base+' fps<br />'+mi+' = '+tcstring(Math.abs(frm0-frm1),base)+' ('+Math.abs(frm0-frm1)+' frames) @ '+base+' fps</h1>';
}

function droptc2frames(h,m,s,f)
{
  t = 60 * h + m;
  return 108000 * h + 1800 * m + 30 * s + f - 2 * (t - Math.floor(t / 10));
}

function timecode2frames(n)
{
 base=$i('base'+n).value;
 df=false;
 if(base==29.97) df=true;

 multiplier= new Array(4);
 multiplier[0]=1;
 multiplier[1]=base;
 multiplier[2]=base*60;
 multiplier[3]=base*60*60;

 tmc=($i('tc'+n).value).split(':', 4);
 frm=0;

 switch(tmc.length)
 {
   case 1: // only frames
   frm=parseInt (tmc[0]);
   if(df)
   frm=droptc2frames(0,0,0,parseInt (tmc[0]));

   break;
   case 2: // s+f
   frm=parseInt (tmc[0])*multiplier[1] + parseInt (tmc[1]);
   if(df)
   frm=droptc2frames(0,0,parseInt (tmc[0]),parseInt (tmc[1]));

   break;
   case 3: // m+s+f
   frm=parseInt (tmc[0])*multiplier[2] +parseInt (tmc[1])*multiplier[1] + parseInt (tmc[2]);
   if(df)
   frm=droptc2frames(0,parseInt (tmc[0]),parseInt (tmc[1]),parseInt (tmc[2]));

   break;
   case 4: // h+m+s+f
   frm=parseInt (tmc[0])*multiplier[3] +parseInt (tmc[1])*multiplier[2] +parseInt (tmc[2])*multiplier[1] + parseInt (tmc[3]);
   if(df)
   frm=droptc2frames(parseInt (tmc[0]),parseInt (tmc[1]),parseInt (tmc[2]),parseInt (tmc[3]));
   break;
 }
 if(frm==-1) frm=0;
 $i('frames'+n).innerHTML='('+frm+' frames)';
 $i('frames'+n+'h').value=frm;
 frames2timecode(n);
 doCalc(base);
}

function tcstring(frm,base)
{
  if(base==29.97)
  {
    base=30;

    h=Math.floor(frm/(60*60*base));

    // now ignore hours
    frm-=h*60*60*base;
    // add 2 drop frames every minute, except for multiples of 10
    m=Math.floor(frm/(60*base));
    mm= parseInt(((m+'').length<2 ? '0'+m : ''+m ).charAt(0))*2;
    frm+=m*2 - mm ;
    m=Math.floor(frm/(60*base));
    s=Math.floor((frm-(m*60*base))/base);
    f=Math.floor(frm-(m*60*base+s*base));

  }
  else
  {
  h=Math.floor(frm/(60*60*base));
  m=Math.floor((frm-h*60*60*base)/(60*base));
  s=Math.floor((frm-(h*60*60*base+m*60*base))/base);
  f=Math.floor(frm-(h*60*60*base+m*60*base+s*base));      if(f>=base) alert("errore base");
  }
  return ((h+'').length<2 ? '0'+h : h ) +':'+ ((m+'').length<2 ? '0'+m : m ) +':'+ ((s+'').length<2 ? '0'+s : s ) +':'+ ((f+'').length<2 ? '0'+f : f );
}

function frames2timecode(n)
{
  frm=parseInt ($i('frames'+n+'h').value);
  base=parseFloat ($i('base'+n).value);
  $i('tc'+n).value= tcstring(frm,base);

}